/*
 *   FreeAdhocUDF - copyright (c) 2004/2006 adhoc dataservice GmbH
 *   Christoph Theuring / Peter Mandrella / Georg Horn
 *   (bug-)reports only to udf@adhoc-data.de
 *      based on FreeUDFLibC - copyright (c) 1999 Gregory Deatz
 *   Declarations script for all FreeAdhocUDF UDFs
 *   Notice: to use with dialect 3 (DATE-field is DATE)
 *   length of some cstring = 8190 or 4095 
 *   because so you can use one this UDF 4 (8) DATEs in a piped string
 *   4 x 8190 = 32760 < 32762 (15 bit - 6 byte internal use)
 *   Functions in alphabetical order
 */

SET SQL DIALECT 1;

/******************************************************************************/
/****                 User Defined Functions: DATE and DATE                ****/
/******************************************************************************/

DECLARE EXTERNAL FUNCTION F_ADDDAY
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDHOUR
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addhour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMINUTE
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addminute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDMONTH
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDSECOND
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addsecond' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDWEEK
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ADDYEAR
    DATE,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'addyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindays' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINDAYSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageindaysthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhours' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINHOURSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinhoursthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTES
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutes' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMINUTESTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinminutes threshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonths' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINMONTHSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinmonthsthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinseconds' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINSECONDSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinsecondsthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeks' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINWEEKSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinweeksthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARS
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyears' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_AGEINYEARSTHRESHOLD
    DATE,
    DATE,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'ageinyearsthreshold' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONG
    DATE
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWLONGLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORT
    DATE
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cdowshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CDOWSHORTLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cdowshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONG
    DATE
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlong' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHLONGLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthlonglang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORT
    DATE
    RETURNS CSTRING(4) FREE_IT
    ENTRY_POINT 'cmonthshort' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_CMONTHSHORTLANG
    DATE,
    CSTRING(2)
    RETURNS CSTRING(16) FREE_IT
    ENTRY_POINT 'cmonthshortlang' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFMONTH
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFWEEK
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofweek' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYOFYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dayofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DAYSOFMONTH
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'daysofmonth' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_DDATE
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'dDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodeDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodeDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ENCODEDATE
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER,
    INTEGER
    RETURNS DATE FREE_IT
    ENTRY_POINT 'encodeDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATE
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_EQUALDATEDATE
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'equalDATEDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_GFORMATD
    CSTRING(254),
    DATE
    RETURNS CSTRING(254) FREE_IT
    ENTRY_POINT 'gformatd' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOUR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hour' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_HOURSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'hoursbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ISLEAPYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'isleapyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_LASTDAY
    INTEGER,
    INTEGER
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'lastday' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MAXDATE
    DATE,
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'maxDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINDATE
    DATE,
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'minDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTE
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minute' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MINUTESBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'minutesbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTH
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'month' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_MONTHSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'monthsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_OSTERDATUM
    INTEGER
    RETURNS DATE
    ENTRY_POINT 'osterdatum' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_QUARTER
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'quarter' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECOND
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'second' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_SECONDSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'secondsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPDATE
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'stripDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRIPDATE
    DATE
    RETURNS DATE FREE_IT
    ENTRY_POINT 'stripDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_STRTODATE
    CSTRING(11)
    RETURNS DATE FREE_IT
    ENTRY_POINT 'strtoDATE' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEK
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'week' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKOFYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weekofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WEEKSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'weeksbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_WOY
    DATE
    RETURNS CSTRING(8) FREE_IT
    ENTRY_POINT 'woy' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'year' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEAROFYEAR
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearofyear' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_YEARSBETWEEN
    DATE,
    DATE
    RETURNS INTEGER FREE_IT
    ENTRY_POINT 'yearsbetween' MODULE_NAME 'FreeAdhocUDF';

DECLARE EXTERNAL FUNCTION F_ZEITDIFFERENZ
    DATE,
    DATE,
    CSTRING(1)
    RETURNS DOUBLE PRECISION FREE_IT
    ENTRY_POINT 'zeitdifferenz' MODULE_NAME 'FreeAdhocUDF';

/* adhoc 2006-12-03 */
